package uulm.teamname.marvelous.server.lobby;

import uulm.teamname.marvelous.gamelibrary.messages.ParticipantType;
import uulm.teamname.marvelous.server.lobbymanager.Participant;

import java.util.Timer;
import java.util.TimerTask;
import java.util.function.Consumer;

public class TurnTimer {
    private final Timer timer;
    private final Consumer<Participant> callback;
    private final int maxRoundTime;

    public TurnTimer(int maxRoundTime, Consumer<Participant> callback) {
        this.timer = new Timer();
        this.maxRoundTime = maxRoundTime;
        this.callback = callback;
    }

    public void startTurnTimer(Participant participant) {
        if (participant.type == ParticipantType.Spectator)
            throw new IllegalStateException("Spectators don't have TurnTime");

        // cancel all current timers, and start a new timer
        timer.cancel();
        timer.schedule(new TimerTask() {
            @Override
            public void run() {
                callback.accept(participant);
            }
        }, maxRoundTime);
    }

    /** cancels all currently running timers */
    public void clear() {
        timer.cancel();
    }
}
