package uulm.teamname.marvelous.server.lobby.pipelining;

import org.tinylog.Logger;
import uulm.teamname.marvelous.gamelibrary.events.Event;
import uulm.teamname.marvelous.gamelibrary.messages.ParticipantType;
import uulm.teamname.marvelous.gamelibrary.requests.RequestType;
import uulm.teamname.marvelous.server.lobby.Lobby;

import java.util.List;
import java.util.concurrent.atomic.AtomicBoolean;

public class DisconnectSegment implements Segment {

    private final Lobby parent;

    public DisconnectSegment(Lobby parent) {
        this.parent = parent;
    }


    @Override
    public void processRequests(Packet packet, List<Event> carrier, AtomicBoolean abort) {
        Logger.trace("DisconnectSegment received {} requests.", packet.size());
        if (packet.containsRequestOfType(RequestType.DisconnectRequest)) {
            Logger.debug("Player of Type {} sent DisconnectRequest", packet.getOrigin().type);
            parent.connection.removePlayer(packet.getOrigin());

            if (packet.getOrigin().type != ParticipantType.Spectator) {
                if(parent.connection.hasPlayer1()){
                    parent.generateWin(parent.connection.getPlayer1());
                }
                else if(parent.connection.hasPlayer2()) {
                    parent.generateWin(parent.connection.getPlayer2());
                }
            }
            packet.clear();
        }
    }
}
