package uulm.teamname.marvelous.server.lobby.pipelining;

import uulm.teamname.marvelous.gamelibrary.requests.Request;
import uulm.teamname.marvelous.gamelibrary.requests.RequestType;
import uulm.teamname.marvelous.server.lobbymanager.Participant;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class Packet extends ArrayList<Request> {

    private final Participant origin;

    public Packet (Request[] requests, Participant origin) {
        this.origin = origin;
        addAll(Arrays.asList(requests));
    }

    public boolean containsRequestOfType(RequestType requiredType) {
        for (Request request : this) {
            if (request.type == requiredType) {
                return true;
            }
        }
        return false;
    }

    public void removeRequestsOfTypes(RequestType... types) {
        var listOfTypes = Arrays.asList(types);
        this.removeIf(request -> listOfTypes.contains(request.type));
    }

    public void removeRequestsNotOfTypes(RequestType... types) {
        var listOfTypes = Arrays.asList(types);
        this.removeIf(request -> !listOfTypes.contains(request.type));
    }

    public Participant getOrigin() {
        return origin;
    }

}
