package uulm.teamname.marvelous.server.lobby.pipelining;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import static org.assertj.core.api.Assertions.*;

class PauseSegmentTest {

    PauseSegment pauseSegment;

    @BeforeEach
    void setUp() {
        pauseSegment = new PauseSegment();
    }

    @Test
    void pauseGame() {
        assertThat(pauseSegment.isPaused()).isFalse();
        pauseSegment.pauseGame();
        assertThat(pauseSegment.isPaused()).isTrue();
        pauseSegment.pauseGame();
        assertThat(pauseSegment.isPaused()).isTrue();
    }

    @Test
    void pauseEnd() {
        assertThat(pauseSegment.isPaused()).isFalse();
        pauseSegment.pauseEnd();
        assertThat(pauseSegment.isPaused()).isFalse();
        pauseSegment.pauseGame();
        assertThat(pauseSegment.isPaused()).isTrue();
        pauseSegment.pauseEnd();
        assertThat(pauseSegment.isPaused()).isFalse();
    }

    @Test
    void processEvents() {
        // TODO: check that events get pipelined normally if not paused, but filtered if paused
        // and check that events work properly
    }
}